// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: MovementStateDefinition.proto

package ru.omnicomm.pegasus.messaging.settings.movement;

public final class MovementStateDefinitionSettingsParser {
  private MovementStateDefinitionSettingsParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public static final class MovementStateDefinitionSettings extends
      com.google.protobuf.GeneratedMessage {
    // Use MovementStateDefinitionSettings.newBuilder() to construct.
    private MovementStateDefinitionSettings() {
      initFields();
    }
    private MovementStateDefinitionSettings(boolean noInit) {}
    
    private static final MovementStateDefinitionSettings defaultInstance;
    public static MovementStateDefinitionSettings getDefaultInstance() {
      return defaultInstance;
    }
    
    public MovementStateDefinitionSettings getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionSettings_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionSettings_fieldAccessorTable;
    }
    
    // required int32 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private boolean hasSourceId;
    private int sourceId_ = 0;
    public boolean hasSourceId() { return hasSourceId; }
    public int getSourceId() { return sourceId_; }
    
    // optional int32 messageType = 2 [default = 526];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private boolean hasMessageType;
    private int messageType_ = 526;
    public boolean hasMessageType() { return hasMessageType; }
    public int getMessageType() { return messageType_; }
    
    // required int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private boolean hasMessageTime;
    private int messageTime_ = 0;
    public boolean hasMessageTime() { return hasMessageTime; }
    public int getMessageTime() { return messageTime_; }
    
    // optional int32 distanceMIN = 101;
    public static final int DISTANCEMIN_FIELD_NUMBER = 101;
    private boolean hasDistanceMIN;
    private int distanceMIN_ = 0;
    public boolean hasDistanceMIN() { return hasDistanceMIN; }
    public int getDistanceMIN() { return distanceMIN_; }
    
    // optional int32 velocityMIN = 102;
    public static final int VELOCITYMIN_FIELD_NUMBER = 102;
    private boolean hasVelocityMIN;
    private int velocityMIN_ = 0;
    public boolean hasVelocityMIN() { return hasVelocityMIN; }
    public int getVelocityMIN() { return velocityMIN_; }
    
    // optional int32 idleMAX = 103;
    public static final int IDLEMAX_FIELD_NUMBER = 103;
    private boolean hasIdleMAX;
    private int idleMAX_ = 0;
    public boolean hasIdleMAX() { return hasIdleMAX; }
    public int getIdleMAX() { return idleMAX_; }
    
    // optional int32 decisionInterval = 104;
    public static final int DECISIONINTERVAL_FIELD_NUMBER = 104;
    private boolean hasDecisionInterval;
    private int decisionInterval_ = 0;
    public boolean hasDecisionInterval() { return hasDecisionInterval; }
    public int getDecisionInterval() { return decisionInterval_; }
    
    private void initFields() {
    }
    public final boolean isInitialized() {
      if (!hasSourceId) return false;
      if (!hasMessageTime) return false;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasSourceId()) {
        output.writeInt32(1, getSourceId());
      }
      if (hasMessageType()) {
        output.writeInt32(2, getMessageType());
      }
      if (hasMessageTime()) {
        output.writeInt32(3, getMessageTime());
      }
      if (hasDistanceMIN()) {
        output.writeInt32(101, getDistanceMIN());
      }
      if (hasVelocityMIN()) {
        output.writeInt32(102, getVelocityMIN());
      }
      if (hasIdleMAX()) {
        output.writeInt32(103, getIdleMAX());
      }
      if (hasDecisionInterval()) {
        output.writeInt32(104, getDecisionInterval());
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasSourceId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(1, getSourceId());
      }
      if (hasMessageType()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, getMessageType());
      }
      if (hasMessageTime()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, getMessageTime());
      }
      if (hasDistanceMIN()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(101, getDistanceMIN());
      }
      if (hasVelocityMIN()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(102, getVelocityMIN());
      }
      if (hasIdleMAX()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(103, getIdleMAX());
      }
      if (hasDecisionInterval()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(104, getDecisionInterval());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings result;
      
      // Construct using ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings();
        return builder;
      }
      
      protected ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings other) {
        if (other == ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasDistanceMIN()) {
          setDistanceMIN(other.getDistanceMIN());
        }
        if (other.hasVelocityMIN()) {
          setVelocityMIN(other.getVelocityMIN());
        }
        if (other.hasIdleMAX()) {
          setIdleMAX(other.getIdleMAX());
        }
        if (other.hasDecisionInterval()) {
          setDecisionInterval(other.getDecisionInterval());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 8: {
              setSourceId(input.readInt32());
              break;
            }
            case 16: {
              setMessageType(input.readInt32());
              break;
            }
            case 24: {
              setMessageTime(input.readInt32());
              break;
            }
            case 808: {
              setDistanceMIN(input.readInt32());
              break;
            }
            case 816: {
              setVelocityMIN(input.readInt32());
              break;
            }
            case 824: {
              setIdleMAX(input.readInt32());
              break;
            }
            case 832: {
              setDecisionInterval(input.readInt32());
              break;
            }
          }
        }
      }
      
      
      // required int32 sourceId = 1;
      public boolean hasSourceId() {
        return result.hasSourceId();
      }
      public int getSourceId() {
        return result.getSourceId();
      }
      public Builder setSourceId(int value) {
        result.hasSourceId = true;
        result.sourceId_ = value;
        return this;
      }
      public Builder clearSourceId() {
        result.hasSourceId = false;
        result.sourceId_ = 0;
        return this;
      }
      
      // optional int32 messageType = 2 [default = 526];
      public boolean hasMessageType() {
        return result.hasMessageType();
      }
      public int getMessageType() {
        return result.getMessageType();
      }
      public Builder setMessageType(int value) {
        result.hasMessageType = true;
        result.messageType_ = value;
        return this;
      }
      public Builder clearMessageType() {
        result.hasMessageType = false;
        result.messageType_ = 526;
        return this;
      }
      
      // required int32 messageTime = 3;
      public boolean hasMessageTime() {
        return result.hasMessageTime();
      }
      public int getMessageTime() {
        return result.getMessageTime();
      }
      public Builder setMessageTime(int value) {
        result.hasMessageTime = true;
        result.messageTime_ = value;
        return this;
      }
      public Builder clearMessageTime() {
        result.hasMessageTime = false;
        result.messageTime_ = 0;
        return this;
      }
      
      // optional int32 distanceMIN = 101;
      public boolean hasDistanceMIN() {
        return result.hasDistanceMIN();
      }
      public int getDistanceMIN() {
        return result.getDistanceMIN();
      }
      public Builder setDistanceMIN(int value) {
        result.hasDistanceMIN = true;
        result.distanceMIN_ = value;
        return this;
      }
      public Builder clearDistanceMIN() {
        result.hasDistanceMIN = false;
        result.distanceMIN_ = 0;
        return this;
      }
      
      // optional int32 velocityMIN = 102;
      public boolean hasVelocityMIN() {
        return result.hasVelocityMIN();
      }
      public int getVelocityMIN() {
        return result.getVelocityMIN();
      }
      public Builder setVelocityMIN(int value) {
        result.hasVelocityMIN = true;
        result.velocityMIN_ = value;
        return this;
      }
      public Builder clearVelocityMIN() {
        result.hasVelocityMIN = false;
        result.velocityMIN_ = 0;
        return this;
      }
      
      // optional int32 idleMAX = 103;
      public boolean hasIdleMAX() {
        return result.hasIdleMAX();
      }
      public int getIdleMAX() {
        return result.getIdleMAX();
      }
      public Builder setIdleMAX(int value) {
        result.hasIdleMAX = true;
        result.idleMAX_ = value;
        return this;
      }
      public Builder clearIdleMAX() {
        result.hasIdleMAX = false;
        result.idleMAX_ = 0;
        return this;
      }
      
      // optional int32 decisionInterval = 104;
      public boolean hasDecisionInterval() {
        return result.hasDecisionInterval();
      }
      public int getDecisionInterval() {
        return result.getDecisionInterval();
      }
      public Builder setDecisionInterval(int value) {
        result.hasDecisionInterval = true;
        result.decisionInterval_ = value;
        return this;
      }
      public Builder clearDecisionInterval() {
        result.hasDecisionInterval = false;
        result.decisionInterval_ = 0;
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettings)
    }
    
    static {
      defaultInstance = new MovementStateDefinitionSettings(true);
      ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettings)
  }
  
  public static final class MovementStateDefinitionBuffer extends
      com.google.protobuf.GeneratedMessage {
    // Use MovementStateDefinitionBuffer.newBuilder() to construct.
    private MovementStateDefinitionBuffer() {
      initFields();
    }
    private MovementStateDefinitionBuffer(boolean noInit) {}
    
    private static final MovementStateDefinitionBuffer defaultInstance;
    public static MovementStateDefinitionBuffer getDefaultInstance() {
      return defaultInstance;
    }
    
    public MovementStateDefinitionBuffer getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_fieldAccessorTable;
    }
    
    public enum State
        implements com.google.protobuf.ProtocolMessageEnum {
      MOVEMENT(0, 1),
      PARKING(1, 2),
      NOT_DEFINED(2, 3),
      ;
      
      
      public final int getNumber() { return value; }
      
      public static State valueOf(int value) {
        switch (value) {
          case 1: return MOVEMENT;
          case 2: return PARKING;
          case 3: return NOT_DEFINED;
          default: return null;
        }
      }
      
      public static com.google.protobuf.Internal.EnumLiteMap<State>
          internalGetValueMap() {
        return internalValueMap;
      }
      private static com.google.protobuf.Internal.EnumLiteMap<State>
          internalValueMap =
            new com.google.protobuf.Internal.EnumLiteMap<State>() {
              public State findValueByNumber(int number) {
                return State.valueOf(number)
      ;        }
            };
      
      public final com.google.protobuf.Descriptors.EnumValueDescriptor
          getValueDescriptor() {
        return getDescriptor().getValues().get(index);
      }
      public final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptorForType() {
        return getDescriptor();
      }
      public static final com.google.protobuf.Descriptors.EnumDescriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.getDescriptor().getEnumTypes().get(0);
      }
      
      private static final State[] VALUES = {
        MOVEMENT, PARKING, NOT_DEFINED, 
      };
      public static State valueOf(
          com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
          throw new java.lang.IllegalArgumentException(
            "EnumValueDescriptor is not for this type.");
        }
        return VALUES[desc.getIndex()];
      }
      private final int index;
      private final int value;
      private State(int index, int value) {
        this.index = index;
        this.value = value;
      }
      
      static {
        ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.getDescriptor();
      }
      
      // @@protoc_insertion_point(enum_scope:ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer.State)
    }
    
    public static final class VelocityData extends
        com.google.protobuf.GeneratedMessage {
      // Use VelocityData.newBuilder() to construct.
      private VelocityData() {
        initFields();
      }
      private VelocityData(boolean noInit) {}
      
      private static final VelocityData defaultInstance;
      public static VelocityData getDefaultInstance() {
        return defaultInstance;
      }
      
      public VelocityData getDefaultInstanceForType() {
        return defaultInstance;
      }
      
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_VelocityData_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_VelocityData_fieldAccessorTable;
      }
      
      // optional int32 dataId = 1;
      public static final int DATAID_FIELD_NUMBER = 1;
      private boolean hasDataId;
      private int dataId_ = 0;
      public boolean hasDataId() { return hasDataId; }
      public int getDataId() { return dataId_; }
      
      // optional int32 value = 2;
      public static final int VALUE_FIELD_NUMBER = 2;
      private boolean hasValue;
      private int value_ = 0;
      public boolean hasValue() { return hasValue; }
      public int getValue() { return value_; }
      
      private void initFields() {
      }
      public final boolean isInitialized() {
        return true;
      }
      
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (hasDataId()) {
          output.writeInt32(1, getDataId());
        }
        if (hasValue()) {
          output.writeInt32(2, getValue());
        }
        getUnknownFields().writeTo(output);
      }
      
      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;
      
        size = 0;
        if (hasDataId()) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt32Size(1, getDataId());
        }
        if (hasValue()) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt32Size(2, getValue());
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }
      
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      
      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }
      
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder> {
        private ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData result;
        
        // Construct using ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData.newBuilder()
        private Builder() {}
        
        private static Builder create() {
          Builder builder = new Builder();
          builder.result = new ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData();
          return builder;
        }
        
        protected ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData internalGetResult() {
          return result;
        }
        
        public Builder clear() {
          if (result == null) {
            throw new IllegalStateException(
              "Cannot call clear() after build().");
          }
          result = new ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData();
          return this;
        }
        
        public Builder clone() {
          return create().mergeFrom(result);
        }
        
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData.getDescriptor();
        }
        
        public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData getDefaultInstanceForType() {
          return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData.getDefaultInstance();
        }
        
        public boolean isInitialized() {
          return result.isInitialized();
        }
        public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData build() {
          if (result != null && !isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return buildPartial();
        }
        
        private ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData buildParsed()
            throws com.google.protobuf.InvalidProtocolBufferException {
          if (!isInitialized()) {
            throw newUninitializedMessageException(
              result).asInvalidProtocolBufferException();
          }
          return buildPartial();
        }
        
        public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData buildPartial() {
          if (result == null) {
            throw new IllegalStateException(
              "build() has already been called on this Builder.");
          }
          ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData returnMe = result;
          result = null;
          return returnMe;
        }
        
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData) {
            return mergeFrom((ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }
        
        public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData other) {
          if (other == ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData.getDefaultInstance()) return this;
          if (other.hasDataId()) {
            setDataId(other.getDataId());
          }
          if (other.hasValue()) {
            setValue(other.getValue());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }
        
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder(
              this.getUnknownFields());
          while (true) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                this.setUnknownFields(unknownFields.build());
                return this;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  this.setUnknownFields(unknownFields.build());
                  return this;
                }
                break;
              }
              case 8: {
                setDataId(input.readInt32());
                break;
              }
              case 16: {
                setValue(input.readInt32());
                break;
              }
            }
          }
        }
        
        
        // optional int32 dataId = 1;
        public boolean hasDataId() {
          return result.hasDataId();
        }
        public int getDataId() {
          return result.getDataId();
        }
        public Builder setDataId(int value) {
          result.hasDataId = true;
          result.dataId_ = value;
          return this;
        }
        public Builder clearDataId() {
          result.hasDataId = false;
          result.dataId_ = 0;
          return this;
        }
        
        // optional int32 value = 2;
        public boolean hasValue() {
          return result.hasValue();
        }
        public int getValue() {
          return result.getValue();
        }
        public Builder setValue(int value) {
          result.hasValue = true;
          result.value_ = value;
          return this;
        }
        public Builder clearValue() {
          result.hasValue = false;
          result.value_ = 0;
          return this;
        }
        
        // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer.VelocityData)
      }
      
      static {
        defaultInstance = new VelocityData(true);
        ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.internalForceInit();
        defaultInstance.initFields();
      }
      
      // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer.VelocityData)
    }
    
    public static final class GpsData extends
        com.google.protobuf.GeneratedMessage {
      // Use GpsData.newBuilder() to construct.
      private GpsData() {
        initFields();
      }
      private GpsData(boolean noInit) {}
      
      private static final GpsData defaultInstance;
      public static GpsData getDefaultInstance() {
        return defaultInstance;
      }
      
      public GpsData getDefaultInstanceForType() {
        return defaultInstance;
      }
      
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_GpsData_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_GpsData_fieldAccessorTable;
      }
      
      // optional int32 dataId = 1;
      public static final int DATAID_FIELD_NUMBER = 1;
      private boolean hasDataId;
      private int dataId_ = 0;
      public boolean hasDataId() { return hasDataId; }
      public int getDataId() { return dataId_; }
      
      // optional double latitude = 2;
      public static final int LATITUDE_FIELD_NUMBER = 2;
      private boolean hasLatitude;
      private double latitude_ = 0D;
      public boolean hasLatitude() { return hasLatitude; }
      public double getLatitude() { return latitude_; }
      
      // optional double longitude = 3;
      public static final int LONGITUDE_FIELD_NUMBER = 3;
      private boolean hasLongitude;
      private double longitude_ = 0D;
      public boolean hasLongitude() { return hasLongitude; }
      public double getLongitude() { return longitude_; }
      
      private void initFields() {
      }
      public final boolean isInitialized() {
        return true;
      }
      
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (hasDataId()) {
          output.writeInt32(1, getDataId());
        }
        if (hasLatitude()) {
          output.writeDouble(2, getLatitude());
        }
        if (hasLongitude()) {
          output.writeDouble(3, getLongitude());
        }
        getUnknownFields().writeTo(output);
      }
      
      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;
      
        size = 0;
        if (hasDataId()) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt32Size(1, getDataId());
        }
        if (hasLatitude()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(2, getLatitude());
        }
        if (hasLongitude()) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(3, getLongitude());
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }
      
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      
      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }
      
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder> {
        private ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData result;
        
        // Construct using ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData.newBuilder()
        private Builder() {}
        
        private static Builder create() {
          Builder builder = new Builder();
          builder.result = new ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData();
          return builder;
        }
        
        protected ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData internalGetResult() {
          return result;
        }
        
        public Builder clear() {
          if (result == null) {
            throw new IllegalStateException(
              "Cannot call clear() after build().");
          }
          result = new ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData();
          return this;
        }
        
        public Builder clone() {
          return create().mergeFrom(result);
        }
        
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData.getDescriptor();
        }
        
        public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData getDefaultInstanceForType() {
          return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData.getDefaultInstance();
        }
        
        public boolean isInitialized() {
          return result.isInitialized();
        }
        public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData build() {
          if (result != null && !isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return buildPartial();
        }
        
        private ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData buildParsed()
            throws com.google.protobuf.InvalidProtocolBufferException {
          if (!isInitialized()) {
            throw newUninitializedMessageException(
              result).asInvalidProtocolBufferException();
          }
          return buildPartial();
        }
        
        public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData buildPartial() {
          if (result == null) {
            throw new IllegalStateException(
              "build() has already been called on this Builder.");
          }
          ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData returnMe = result;
          result = null;
          return returnMe;
        }
        
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData) {
            return mergeFrom((ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }
        
        public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData other) {
          if (other == ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData.getDefaultInstance()) return this;
          if (other.hasDataId()) {
            setDataId(other.getDataId());
          }
          if (other.hasLatitude()) {
            setLatitude(other.getLatitude());
          }
          if (other.hasLongitude()) {
            setLongitude(other.getLongitude());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }
        
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder(
              this.getUnknownFields());
          while (true) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                this.setUnknownFields(unknownFields.build());
                return this;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  this.setUnknownFields(unknownFields.build());
                  return this;
                }
                break;
              }
              case 8: {
                setDataId(input.readInt32());
                break;
              }
              case 17: {
                setLatitude(input.readDouble());
                break;
              }
              case 25: {
                setLongitude(input.readDouble());
                break;
              }
            }
          }
        }
        
        
        // optional int32 dataId = 1;
        public boolean hasDataId() {
          return result.hasDataId();
        }
        public int getDataId() {
          return result.getDataId();
        }
        public Builder setDataId(int value) {
          result.hasDataId = true;
          result.dataId_ = value;
          return this;
        }
        public Builder clearDataId() {
          result.hasDataId = false;
          result.dataId_ = 0;
          return this;
        }
        
        // optional double latitude = 2;
        public boolean hasLatitude() {
          return result.hasLatitude();
        }
        public double getLatitude() {
          return result.getLatitude();
        }
        public Builder setLatitude(double value) {
          result.hasLatitude = true;
          result.latitude_ = value;
          return this;
        }
        public Builder clearLatitude() {
          result.hasLatitude = false;
          result.latitude_ = 0D;
          return this;
        }
        
        // optional double longitude = 3;
        public boolean hasLongitude() {
          return result.hasLongitude();
        }
        public double getLongitude() {
          return result.getLongitude();
        }
        public Builder setLongitude(double value) {
          result.hasLongitude = true;
          result.longitude_ = value;
          return this;
        }
        public Builder clearLongitude() {
          result.hasLongitude = false;
          result.longitude_ = 0D;
          return this;
        }
        
        // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer.GpsData)
      }
      
      static {
        defaultInstance = new GpsData(true);
        ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.internalForceInit();
        defaultInstance.initFields();
      }
      
      // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer.GpsData)
    }
    
    // required int32 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private boolean hasSourceId;
    private int sourceId_ = 0;
    public boolean hasSourceId() { return hasSourceId; }
    public int getSourceId() { return sourceId_; }
    
    // optional int32 messageType = 2 [default = 527];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private boolean hasMessageType;
    private int messageType_ = 527;
    public boolean hasMessageType() { return hasMessageType; }
    public int getMessageType() { return messageType_; }
    
    // required int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private boolean hasMessageTime;
    private int messageTime_ = 0;
    public boolean hasMessageTime() { return hasMessageTime; }
    public int getMessageTime() { return messageTime_; }
    
    // optional int32 distanceMIN = 101;
    public static final int DISTANCEMIN_FIELD_NUMBER = 101;
    private boolean hasDistanceMIN;
    private int distanceMIN_ = 0;
    public boolean hasDistanceMIN() { return hasDistanceMIN; }
    public int getDistanceMIN() { return distanceMIN_; }
    
    // optional int32 velocityMIN = 102;
    public static final int VELOCITYMIN_FIELD_NUMBER = 102;
    private boolean hasVelocityMIN;
    private int velocityMIN_ = 0;
    public boolean hasVelocityMIN() { return hasVelocityMIN; }
    public int getVelocityMIN() { return velocityMIN_; }
    
    // optional int32 idleMAX = 103;
    public static final int IDLEMAX_FIELD_NUMBER = 103;
    private boolean hasIdleMAX;
    private int idleMAX_ = 0;
    public boolean hasIdleMAX() { return hasIdleMAX; }
    public int getIdleMAX() { return idleMAX_; }
    
    // optional int32 decisionInterval = 104;
    public static final int DECISIONINTERVAL_FIELD_NUMBER = 104;
    private boolean hasDecisionInterval;
    private int decisionInterval_ = 0;
    public boolean hasDecisionInterval() { return hasDecisionInterval; }
    public int getDecisionInterval() { return decisionInterval_; }
    
    // repeated .ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer.VelocityData velocityBuffer = 105;
    public static final int VELOCITYBUFFER_FIELD_NUMBER = 105;
    private java.util.List<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData> velocityBuffer_ =
      java.util.Collections.emptyList();
    public java.util.List<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData> getVelocityBufferList() {
      return velocityBuffer_;
    }
    public int getVelocityBufferCount() { return velocityBuffer_.size(); }
    public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData getVelocityBuffer(int index) {
      return velocityBuffer_.get(index);
    }
    
    // repeated .ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer.GpsData gpsBuffer = 106;
    public static final int GPSBUFFER_FIELD_NUMBER = 106;
    private java.util.List<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData> gpsBuffer_ =
      java.util.Collections.emptyList();
    public java.util.List<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData> getGpsBufferList() {
      return gpsBuffer_;
    }
    public int getGpsBufferCount() { return gpsBuffer_.size(); }
    public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData getGpsBuffer(int index) {
      return gpsBuffer_.get(index);
    }
    
    // optional .ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer.State currentState = 200;
    public static final int CURRENTSTATE_FIELD_NUMBER = 200;
    private boolean hasCurrentState;
    private ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.State currentState_;
    public boolean hasCurrentState() { return hasCurrentState; }
    public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.State getCurrentState() { return currentState_; }
    
    private void initFields() {
      currentState_ = ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.State.MOVEMENT;
    }
    public final boolean isInitialized() {
      if (!hasSourceId) return false;
      if (!hasMessageTime) return false;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (hasSourceId()) {
        output.writeInt32(1, getSourceId());
      }
      if (hasMessageType()) {
        output.writeInt32(2, getMessageType());
      }
      if (hasMessageTime()) {
        output.writeInt32(3, getMessageTime());
      }
      if (hasDistanceMIN()) {
        output.writeInt32(101, getDistanceMIN());
      }
      if (hasVelocityMIN()) {
        output.writeInt32(102, getVelocityMIN());
      }
      if (hasIdleMAX()) {
        output.writeInt32(103, getIdleMAX());
      }
      if (hasDecisionInterval()) {
        output.writeInt32(104, getDecisionInterval());
      }
      for (ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData element : getVelocityBufferList()) {
        output.writeMessage(105, element);
      }
      for (ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData element : getGpsBufferList()) {
        output.writeMessage(106, element);
      }
      if (hasCurrentState()) {
        output.writeEnum(200, getCurrentState().getNumber());
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (hasSourceId()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(1, getSourceId());
      }
      if (hasMessageType()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, getMessageType());
      }
      if (hasMessageTime()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, getMessageTime());
      }
      if (hasDistanceMIN()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(101, getDistanceMIN());
      }
      if (hasVelocityMIN()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(102, getVelocityMIN());
      }
      if (hasIdleMAX()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(103, getIdleMAX());
      }
      if (hasDecisionInterval()) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(104, getDecisionInterval());
      }
      for (ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData element : getVelocityBufferList()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(105, element);
      }
      for (ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData element : getGpsBufferList()) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(106, element);
      }
      if (hasCurrentState()) {
        size += com.google.protobuf.CodedOutputStream
          .computeEnumSize(200, getCurrentState().getNumber());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder> {
      private ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer result;
      
      // Construct using ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.newBuilder()
      private Builder() {}
      
      private static Builder create() {
        Builder builder = new Builder();
        builder.result = new ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer();
        return builder;
      }
      
      protected ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer internalGetResult() {
        return result;
      }
      
      public Builder clear() {
        if (result == null) {
          throw new IllegalStateException(
            "Cannot call clear() after build().");
        }
        result = new ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer();
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(result);
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.getDefaultInstance();
      }
      
      public boolean isInitialized() {
        return result.isInitialized();
      }
      public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer build() {
        if (result != null && !isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return buildPartial();
      }
      
      private ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        if (!isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return buildPartial();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer buildPartial() {
        if (result == null) {
          throw new IllegalStateException(
            "build() has already been called on this Builder.");
        }
        if (result.velocityBuffer_ != java.util.Collections.EMPTY_LIST) {
          result.velocityBuffer_ =
            java.util.Collections.unmodifiableList(result.velocityBuffer_);
        }
        if (result.gpsBuffer_ != java.util.Collections.EMPTY_LIST) {
          result.gpsBuffer_ =
            java.util.Collections.unmodifiableList(result.gpsBuffer_);
        }
        ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer returnMe = result;
        result = null;
        return returnMe;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer other) {
        if (other == ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasDistanceMIN()) {
          setDistanceMIN(other.getDistanceMIN());
        }
        if (other.hasVelocityMIN()) {
          setVelocityMIN(other.getVelocityMIN());
        }
        if (other.hasIdleMAX()) {
          setIdleMAX(other.getIdleMAX());
        }
        if (other.hasDecisionInterval()) {
          setDecisionInterval(other.getDecisionInterval());
        }
        if (!other.velocityBuffer_.isEmpty()) {
          if (result.velocityBuffer_.isEmpty()) {
            result.velocityBuffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData>();
          }
          result.velocityBuffer_.addAll(other.velocityBuffer_);
        }
        if (!other.gpsBuffer_.isEmpty()) {
          if (result.gpsBuffer_.isEmpty()) {
            result.gpsBuffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData>();
          }
          result.gpsBuffer_.addAll(other.gpsBuffer_);
        }
        if (other.hasCurrentState()) {
          setCurrentState(other.getCurrentState());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                return this;
              }
              break;
            }
            case 8: {
              setSourceId(input.readInt32());
              break;
            }
            case 16: {
              setMessageType(input.readInt32());
              break;
            }
            case 24: {
              setMessageTime(input.readInt32());
              break;
            }
            case 808: {
              setDistanceMIN(input.readInt32());
              break;
            }
            case 816: {
              setVelocityMIN(input.readInt32());
              break;
            }
            case 824: {
              setIdleMAX(input.readInt32());
              break;
            }
            case 832: {
              setDecisionInterval(input.readInt32());
              break;
            }
            case 842: {
              ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData.Builder subBuilder = ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addVelocityBuffer(subBuilder.buildPartial());
              break;
            }
            case 850: {
              ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData.Builder subBuilder = ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addGpsBuffer(subBuilder.buildPartial());
              break;
            }
            case 1600: {
              int rawValue = input.readEnum();
              ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.State value = ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.State.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(200, rawValue);
              } else {
                setCurrentState(value);
              }
              break;
            }
          }
        }
      }
      
      
      // required int32 sourceId = 1;
      public boolean hasSourceId() {
        return result.hasSourceId();
      }
      public int getSourceId() {
        return result.getSourceId();
      }
      public Builder setSourceId(int value) {
        result.hasSourceId = true;
        result.sourceId_ = value;
        return this;
      }
      public Builder clearSourceId() {
        result.hasSourceId = false;
        result.sourceId_ = 0;
        return this;
      }
      
      // optional int32 messageType = 2 [default = 527];
      public boolean hasMessageType() {
        return result.hasMessageType();
      }
      public int getMessageType() {
        return result.getMessageType();
      }
      public Builder setMessageType(int value) {
        result.hasMessageType = true;
        result.messageType_ = value;
        return this;
      }
      public Builder clearMessageType() {
        result.hasMessageType = false;
        result.messageType_ = 527;
        return this;
      }
      
      // required int32 messageTime = 3;
      public boolean hasMessageTime() {
        return result.hasMessageTime();
      }
      public int getMessageTime() {
        return result.getMessageTime();
      }
      public Builder setMessageTime(int value) {
        result.hasMessageTime = true;
        result.messageTime_ = value;
        return this;
      }
      public Builder clearMessageTime() {
        result.hasMessageTime = false;
        result.messageTime_ = 0;
        return this;
      }
      
      // optional int32 distanceMIN = 101;
      public boolean hasDistanceMIN() {
        return result.hasDistanceMIN();
      }
      public int getDistanceMIN() {
        return result.getDistanceMIN();
      }
      public Builder setDistanceMIN(int value) {
        result.hasDistanceMIN = true;
        result.distanceMIN_ = value;
        return this;
      }
      public Builder clearDistanceMIN() {
        result.hasDistanceMIN = false;
        result.distanceMIN_ = 0;
        return this;
      }
      
      // optional int32 velocityMIN = 102;
      public boolean hasVelocityMIN() {
        return result.hasVelocityMIN();
      }
      public int getVelocityMIN() {
        return result.getVelocityMIN();
      }
      public Builder setVelocityMIN(int value) {
        result.hasVelocityMIN = true;
        result.velocityMIN_ = value;
        return this;
      }
      public Builder clearVelocityMIN() {
        result.hasVelocityMIN = false;
        result.velocityMIN_ = 0;
        return this;
      }
      
      // optional int32 idleMAX = 103;
      public boolean hasIdleMAX() {
        return result.hasIdleMAX();
      }
      public int getIdleMAX() {
        return result.getIdleMAX();
      }
      public Builder setIdleMAX(int value) {
        result.hasIdleMAX = true;
        result.idleMAX_ = value;
        return this;
      }
      public Builder clearIdleMAX() {
        result.hasIdleMAX = false;
        result.idleMAX_ = 0;
        return this;
      }
      
      // optional int32 decisionInterval = 104;
      public boolean hasDecisionInterval() {
        return result.hasDecisionInterval();
      }
      public int getDecisionInterval() {
        return result.getDecisionInterval();
      }
      public Builder setDecisionInterval(int value) {
        result.hasDecisionInterval = true;
        result.decisionInterval_ = value;
        return this;
      }
      public Builder clearDecisionInterval() {
        result.hasDecisionInterval = false;
        result.decisionInterval_ = 0;
        return this;
      }
      
      // repeated .ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer.VelocityData velocityBuffer = 105;
      public java.util.List<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData> getVelocityBufferList() {
        return java.util.Collections.unmodifiableList(result.velocityBuffer_);
      }
      public int getVelocityBufferCount() {
        return result.getVelocityBufferCount();
      }
      public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData getVelocityBuffer(int index) {
        return result.getVelocityBuffer(index);
      }
      public Builder setVelocityBuffer(int index, ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.velocityBuffer_.set(index, value);
        return this;
      }
      public Builder setVelocityBuffer(int index, ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData.Builder builderForValue) {
        result.velocityBuffer_.set(index, builderForValue.build());
        return this;
      }
      public Builder addVelocityBuffer(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData value) {
        if (value == null) {
          throw new NullPointerException();
        }
        if (result.velocityBuffer_.isEmpty()) {
          result.velocityBuffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData>();
        }
        result.velocityBuffer_.add(value);
        return this;
      }
      public Builder addVelocityBuffer(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData.Builder builderForValue) {
        if (result.velocityBuffer_.isEmpty()) {
          result.velocityBuffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData>();
        }
        result.velocityBuffer_.add(builderForValue.build());
        return this;
      }
      public Builder addAllVelocityBuffer(
          java.lang.Iterable<? extends ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData> values) {
        if (result.velocityBuffer_.isEmpty()) {
          result.velocityBuffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData>();
        }
        super.addAll(values, result.velocityBuffer_);
        return this;
      }
      public Builder clearVelocityBuffer() {
        result.velocityBuffer_ = java.util.Collections.emptyList();
        return this;
      }
      
      // repeated .ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer.GpsData gpsBuffer = 106;
      public java.util.List<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData> getGpsBufferList() {
        return java.util.Collections.unmodifiableList(result.gpsBuffer_);
      }
      public int getGpsBufferCount() {
        return result.getGpsBufferCount();
      }
      public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData getGpsBuffer(int index) {
        return result.getGpsBuffer(index);
      }
      public Builder setGpsBuffer(int index, ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.gpsBuffer_.set(index, value);
        return this;
      }
      public Builder setGpsBuffer(int index, ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData.Builder builderForValue) {
        result.gpsBuffer_.set(index, builderForValue.build());
        return this;
      }
      public Builder addGpsBuffer(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData value) {
        if (value == null) {
          throw new NullPointerException();
        }
        if (result.gpsBuffer_.isEmpty()) {
          result.gpsBuffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData>();
        }
        result.gpsBuffer_.add(value);
        return this;
      }
      public Builder addGpsBuffer(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData.Builder builderForValue) {
        if (result.gpsBuffer_.isEmpty()) {
          result.gpsBuffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData>();
        }
        result.gpsBuffer_.add(builderForValue.build());
        return this;
      }
      public Builder addAllGpsBuffer(
          java.lang.Iterable<? extends ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData> values) {
        if (result.gpsBuffer_.isEmpty()) {
          result.gpsBuffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData>();
        }
        super.addAll(values, result.gpsBuffer_);
        return this;
      }
      public Builder clearGpsBuffer() {
        result.gpsBuffer_ = java.util.Collections.emptyList();
        return this;
      }
      
      // optional .ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer.State currentState = 200;
      public boolean hasCurrentState() {
        return result.hasCurrentState();
      }
      public ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.State getCurrentState() {
        return result.getCurrentState();
      }
      public Builder setCurrentState(ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.State value) {
        if (value == null) {
          throw new NullPointerException();
        }
        result.hasCurrentState = true;
        result.currentState_ = value;
        return this;
      }
      public Builder clearCurrentState() {
        result.hasCurrentState = false;
        result.currentState_ = ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.State.MOVEMENT;
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer)
    }
    
    static {
      defaultInstance = new MovementStateDefinitionBuffer(true);
      ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.internalForceInit();
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionBuffer)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionSettings_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionSettings_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_VelocityData_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_VelocityData_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_GpsData_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_GpsData_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\035MovementStateDefinition.proto\022/ru.omni" +
      "comm.pegasus.messaging.settings.movement" +
      "\"\267\001\n\037MovementStateDefinitionSettings\022\020\n\010" +
      "sourceId\030\001 \002(\005\022\030\n\013messageType\030\002 \001(\005:\003526" +
      "\022\023\n\013messageTime\030\003 \002(\005\022\023\n\013distanceMIN\030e \001" +
      "(\005\022\023\n\013velocityMIN\030f \001(\005\022\017\n\007idleMAX\030g \001(\005" +
      "\022\030\n\020decisionInterval\030h \001(\005\"\246\005\n\035MovementS" +
      "tateDefinitionBuffer\022\020\n\010sourceId\030\001 \002(\005\022\030" +
      "\n\013messageType\030\002 \001(\005:\003527\022\023\n\013messageTime\030" +
      "\003 \002(\005\022\023\n\013distanceMIN\030e \001(\005\022\023\n\013velocityMI",
      "N\030f \001(\005\022\017\n\007idleMAX\030g \001(\005\022\030\n\020decisionInte" +
      "rval\030h \001(\005\022s\n\016velocityBuffer\030i \003(\0132[.ru." +
      "omnicomm.pegasus.messaging.settings.move" +
      "ment.MovementStateDefinitionBuffer.Veloc" +
      "ityData\022i\n\tgpsBuffer\030j \003(\0132V.ru.omnicomm" +
      ".pegasus.messaging.settings.movement.Mov" +
      "ementStateDefinitionBuffer.GpsData\022k\n\014cu" +
      "rrentState\030\310\001 \001(\0162T.ru.omnicomm.pegasus." +
      "messaging.settings.movement.MovementStat" +
      "eDefinitionBuffer.State\032-\n\014VelocityData\022",
      "\016\n\006dataId\030\001 \001(\005\022\r\n\005value\030\002 \001(\005\032>\n\007GpsDat" +
      "a\022\016\n\006dataId\030\001 \001(\005\022\020\n\010latitude\030\002 \001(\001\022\021\n\tl" +
      "ongitude\030\003 \001(\001\"3\n\005State\022\014\n\010MOVEMENT\020\001\022\013\n" +
      "\007PARKING\020\002\022\017\n\013NOT_DEFINED\020\003BX\n/ru.omnico" +
      "mm.pegasus.messaging.settings.movementB%" +
      "MovementStateDefinitionSettingsParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionSettings_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionSettings_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionSettings_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "DistanceMIN", "VelocityMIN", "IdleMAX", "DecisionInterval", },
              ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings.class,
              ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionSettings.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_descriptor =
            getDescriptor().getMessageTypes().get(1);
          internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "DistanceMIN", "VelocityMIN", "IdleMAX", "DecisionInterval", "VelocityBuffer", "GpsBuffer", "CurrentState", },
              ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.class,
              ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_VelocityData_descriptor =
            internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_descriptor.getNestedTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_VelocityData_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_VelocityData_descriptor,
              new java.lang.String[] { "DataId", "Value", },
              ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData.class,
              ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.VelocityData.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_GpsData_descriptor =
            internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_descriptor.getNestedTypes().get(1);
          internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_GpsData_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_movement_MovementStateDefinitionBuffer_GpsData_descriptor,
              new java.lang.String[] { "DataId", "Latitude", "Longitude", },
              ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData.class,
              ru.omnicomm.pegasus.messaging.settings.movement.MovementStateDefinitionSettingsParser.MovementStateDefinitionBuffer.GpsData.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  public static void internalForceInit() {}
  
  // @@protoc_insertion_point(outer_class_scope)
}
